javax.servlet.annotation

## Annotation Type HttpConstraint

-     @Documented
      @Retention(value=RUNTIME)
      public @interface HttpConstraint

  This annotation is used within the `ServletSecurity` annotation to represent the security constraints to be applied to all HTTP protocol methods for which a corresponding `HttpMethodConstraint` element does NOT occur within the `ServletSecurity` annotation.

  For the special case where an `@HttpConstraint` that returns all default values occurs in combination with at least one `HttpMethodConstraint` that returns other than all default values, the `@HttpConstraint` represents that no security constraint is to be applied to any of the HTTP protocol methods to which a security constraint would otherwise apply. This exception is made to ensure that such potentially non-specific uses of `@HttpConstraint` do not yield constraints that will explicitly establish unprotected access for such methods; given that they would not otherwise be covered by a constraint.

  Since:
    Servlet 3.0

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `String[]` | `rolesAllowed` The names of the authorized roles.
    `ServletSecurity.TransportGuarantee` | `transportGuarantee` The data protection requirements (i.e., whether or not SSL/TLS is required) that must be satisfied by the connections on which requests arrive.
    `ServletSecurity.EmptyRoleSemantic` | `value` The default authorization semantic.

- - ### Element Detail

    - #### value

          public abstract ServletSecurity.EmptyRoleSemantic value

      The default authorization semantic. This value is insignificant when `rolesAllowed` returns a non-empty array, and should not be specified when a non-empty array is specified for `rolesAllowed`.``
      Returns:
        the `ServletSecurity.EmptyRoleSemantic` to be applied when `rolesAllowed` returns an empty (that is, zero-length) array.
      Default:
        javax.servlet.annotation.ServletSecurity.EmptyRoleSemantic.PERMIT

    - #### transportGuarantee

          public abstract ServletSecurity.TransportGuarantee transportGuarantee

      The data protection requirements (i.e., whether or not SSL/TLS is required) that must be satisfied by the connections on which requests arrive.
      Returns:
        the `ServletSecurity.TransportGuarantee` indicating the data protection that must be provided by the connection.
      Default:
        javax.servlet.annotation.ServletSecurity.TransportGuarantee.NONE

    - #### rolesAllowed

          public abstract String[] rolesAllowed

      The names of the authorized roles. Duplicate role names appearing in rolesAllowed are insignificant and may be discarded during runtime processing of the annotation. The String `"*"` has no special meaning as a role name (should it occur in rolesAllowed).
      Returns:
        an array of zero or more role names. When the array contains zero elements, its meaning depends on the `EmptyRoleSemantic` returned by the `value` method. If `value` returns `DENY`, and `rolesAllowed` returns a zero length array, access is to be denied independent of authentication state and identity. Conversely, if `value` returns `PERMIT`, it indicates that access is to be allowed independent of authentication state and identity. When the array contains the names of one or more roles, it indicates that access is contingent on membership in at least one of the named roles (independent of the `EmptyRoleSemantic` returned by the `value` method).
      Default:
        {}

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.